#include <fork.h>
#include <syscall.h>
#include <io.h>
#include <assert.h>
#include <Matrix.h>

sh int N = 8;

void
main(int ac, char *av[])
{

    if (!__PROC_NR__) {
        if (ac > 1) {
            N = atoi(av[1]);
        }
    }

    barrier;

    if (N <= 0)
        exit(1);

    start {
        sh Matrix A, B, C;
        sh int p = groupsize();
        int i, j;

        A = new_Matrix(N, N, 0);
        B = new_Matrix(N, N, 0);
        C = new_Matrix(N, N, 0);

        farm
            forall(i, 0, N, p)
                for (j = 0; j < N; j++) {
                    Set(A, i,j, 1.0);
                    Set(B, i,j, 2.0);
                }

        Mul(A, B, C);
    }

    exit(0);
}

