/*************************************************/
/*                                               */
/*      mpi_ops.h                                */
/*      mpi Reduce Operations lib in fork95      */
/*      v0.01                                    */
/*      05.10.1999 Christoph W. Kessler,         */
/*      Oliver Fritzen                           */
/*************************************************/

#include "mpi.h"

extern async int mpi_sum(void *out,  void *in, int  *len, MPI_Datatype *type);
/* add over n vectors, returns one sum vector */

extern async int mpi_max(void *out,  void *in, int  *len, MPI_Datatype *type);
/* max over n vectors, returns one max vector */

extern async int mpi_min(void *out,  void *in, int  *len, MPI_Datatype *type);
/* min over n vectors, returns one min vector */

extern async int mpi_prod(void *out,  void *in, int  *len, MPI_Datatype *type);
  /* product over n vectors, returns one product vector */
  
extern async int mpi_land(void *out,  void *in, int  *len, MPI_Datatype *type);
  /* logical and over n vectors, returns one LAND vector */
  
extern async int mpi_band(void *out,  void *in, int  *len, MPI_Datatype *type);
/* bitwise and over n vectors, returns one BAND vector */

extern async int mpi_lor(void *out,  void *in, int  *len, MPI_Datatype *type);
/* logical or over n vectors, returns one LOR vector */

extern async int mpi_bor(void *out,  void *in, int  *len, MPI_Datatype *type);
  /* bitwise or over n vectors, returns one BOR vector */
  
extern async int mpi_lxor(void *out,  void *in, int  *len, MPI_Datatype *type);
  /* logical xor over n vectors, returns one LXOR vector */
  
extern async int mpi_bxor(void *out,  void *in, int  *len, MPI_Datatype *type);
  /* bitwise or over n vectors, returns one BXOR vector */
  
extern async int mpi_maxloc(void *out,  void *in, int  *len, MPI_Datatype *type);
/* max over n vectors, returns one max vector plus its index */

extern async int mpi_minloc(void *out,  void *in, int  *len, MPI_Datatype *type);
/* min over n vectors, returns one min vector plus its index */
  
